/// <reference types="node" />
import type { IncomingHttpHeaders } from 'http';
import type { Request } from 'express';
export declare type ParsedQuery = {
    [key: string]: undefined | string | string[] | ParsedQuery | ParsedQuery[];
};
export declare type BrowserData = {
    connection: {
        secure: boolean;
        headers: IncomingHttpHeaders;
        body: any;
    };
    location: {
        host: string;
        hostname: string;
        href: string;
        origin: string;
        pathname: string;
        port: number;
        protocol: string;
        query: ParsedQuery;
        url: string;
    };
    cookie?: string;
};
export declare function requestToObj(req: Request, port: number): BrowserData;
